------------------------------------------------
--  GENERIC DAVTRON M903I
-- VOR INDICATOR
-- version 1.20

-- Jacques ZAHAR 18 June 2022
------------------------------------------------
--------------- Customization variable -------
ident_display_time=2000 -- time during which each ident letter is displayed (msec)

--------------- Graphic ressources ---------
rect_id = canvas_add(0, 0, 362, 362, function() 
      _rect(30,90,350,150)
      _fill("#150308")
      end)
      
img_add_fullscreen("bezel.png")
   
display_str=txt_add("- - -", "font:digital-7-mono.ttf; size:60; color: orange; halign:left;", 75, 125, 250, 200)
id_str=txt_add(" ", "font:digital-7-mono.ttf; size:60; color: orange; halign:right;", 50, 125, 240, 200)

display_grp=group_add(display_str,id_str)
visible(display_grp,false)

triple_bar_img=img_add("triple_bar.png",120,130,43,55)
visible(triple_bar_img,false)

--------------- Global vars -------------------
id_string=" "
str=""
str1=""
nav_ident=""
index=0 
nav_radial_error=20
nav_has_nav=false
nav_has_loc=false
nav_radial=0
nav_radial_error=0
nav_ident=""
radial_from=false
active_nav=1
-----------------Buttons ---------------------
function test_callback_pressed() -- Dummy test sequence, a fake voltage value is displayed
    txt_set(display_str,"0 7 0")-- dummy voltage value
    txt_set(id_str," ")
end

function test_callback_released()
    txt_set(display_str,"- - -")
    txt_set(id_str," ")
    index=0
    request_callback(display_params)
end

button_id=button_add("button_off.png","button_on.png",169,248,20,20,test_callback_pressed,test_callback_released)

function nav_callback(position,direction)
    position=position+direction
    switch_set_position(switchnav_id,position)
    --print(position)
    if position==0 then active_nav=1 else active_nav=2 end
    --resets the ID
    timer_stop(display_id_tmr)
    txt_set(id_str," ")
    index=0
    request_callback(display_params)
    
end

switchnav_id=switch_add("toggle_hor_off.png", "toggle_hor_on.png", 98,235,45,45,"HORIZONTAL",nav_callback)

function nav_set(value)

    --print(position)
    if value==0 then
        active_nav=1 
        switch_set_position(switchnav_id,0)     
    else
        active_nav=2
        switch_set_position(switchnav_id,1) 
    end
    --resets the ID
    timer_stop(display_id_tmr)
    txt_set(id_str," ")
    index=0
    request_callback(display_params)
end

fsx_variable_subscribe("L:DvorNavSwitch","NUMBER",nav_set) 
--------------   
function tofrom_callback(position,direction)
    position=position+direction
    if position==1 then 
        radial_from=true
    else
        radial_from=false
    end
    switch_set_position(switchtofrom_id,position)
    request_callback(display_params)
end

switchtofrom_id =  switch_add("toggle_hor_off.png", "toggle_hor_on.png", 225,235,45,45,"HORIZONTAL",tofrom_callback)

function tofrom_set(value)

    if value==1 then 
        radial_from=true
        switch_set_position(switchtofrom_id,1)
    else
        radial_from=false
        switch_set_position(switchtofrom_id,0)        
    end

    request_callback(display_params)
end

fsx_variable_subscribe("L:DvorToFromSwitch","NUMBER",tofrom_set)
-------------------- Functions -----------------------------

function display_id()
--print(nav_ident)
    if nav_ident~="" then 
           --print("in")
           if index> string.len(nav_ident) then index=0 end
           index=index+1
           --print("len:"..string.len(nav_ident))          
           id_string=string.sub(nav_ident,index,index)
           --print(index..":"..id_string)
           txt_set(id_str,id_string)
     else
           txt_set(id_str," ")
     end       
end 


function display_params(nav1_has_nav,nav1_has_loc,nav1_id,nav1_radial,nav1_radial_err,nav2_has_nav,nav2_has_loc,nav2_id,nav2_radial,nav2_radial_err,avionics,avionics_bus)
if active_nav==1 then
    nav_has_nav=nav1_has_nav
    nav_has_loc=nav1_has_loc
    nav_radial=nav1_radial
    nav_radial_error=nav1_radial_err*4 --(4 dots per degree of deviation (+/-2.5 degrees = 10)
    nav_ident=nav1_id
else
    nav_has_nav=nav2_has_nav
    nav_has_loc=nav2_has_loc
    nav_radial=nav2_radial
    nav_radial_error=nav2_radial_err*4
    nav_ident=nav2_id
end

if nav_has_nav==true then 
        if nav_has_loc==false then -- display radial and ident
            visible(triple_bar_img,false)
            print("RAD:"..nav_radial)
            if radial_from==true then -- FROM radial
--                 if nav_radial<0 then
--                   str1=string.format("%03i",math.ceil(nav_radial+360)%360)                
--                 else  
print("FROM")  
                  str1=string.format("%03i",math.ceil(nav_radial)%360)
                --end
                else -- TO radial
print("TO")
                  if nav_radial<0 then
                          str1=string.format("%03i",math.ceil((180+nav_radial)%360))
                   elseif nav_radial<180 then                        
                          str1=string.format("%03i",math.ceil((nav_radial+180)%360))
                   else
                          str1=string.format("%03i",math.ceil((nav_radial-180)%360))
                   end
                end
            str=""
            for i=1,3 do -- ajoute les espaces
                str=str..string.sub(str1,i,i).." "
            end
            --print("rad:"..str)
            txt_set(display_str,str)
            if nav_ident~=""  then 
                    
                    if not(timer_running(display_id_tmr)) then 
                        index=0
                        display_id_tmr=timer_start(0,ident_display_time,display_id)
                     end     
                else 
                    timer_stop(display_id_tmr)
                    txt_set(id_str," ")
                    index=0
                end
        else 
            -- LOC mode
            timer_stop(display_id_tmr)
            str="  -  "
            txt_set(display_str,str)
            txt_set(id_str,"x")
            visible(triple_bar_img,false)
            print("loc"..nav_radial_error)
            
            if nav_radial_error>20.0 then nav_radial_error=20.0 end
            if nav_radial_error<-20.0 then nav_radial_error=-20.0 end
            
            if nav_radial_error>=1.0 then --0.5 then -- deviation to the left
                if nav_radial_error<10.0 then 
                        str=string.format("%01i",var_format(nav_radial_error,0)).." -"
                    else
                        str=string.format("%01i",var_format(nav_radial_error/10,0)).." "..string.sub(var_format(nav_radial_error,0),-1).." -"
                   end
                print(str)
                txt_set(display_str,str)    
                visible(triple_bar_img,false)     
                elseif nav_radial_error<=-1.0 then---0.5 then-- deviation to the right
                    if nav_radial_error>-10.0 then 
                        str="  - "..string.format("%01i",math.abs(var_format(nav_radial_error,0)))
                    else
                        str="- "..string.format("%01i",math.abs(var_format(nav_radial_error/10,0))).." "..string.sub(var_format(nav_radial_error,0),-1)
                    end
                txt_set(display_str,str)    
                visible(triple_bar_img,false)    
                else -- dead center (+/-0.5)
                    visible(triple_bar_img,avionics==true)
                    str=""
                    txt_set(display_str,str)
                end --  if nav1_radial_error>0.0

       end -- nav has loc   
    else -- nav unavailable
        timer_stop(display_id_tmr)
        str="- - -"
        txt_set(display_str,str)
        txt_set(id_str," ")
        visible(triple_bar_img,false)
    end
 visible(display_grp,avionics==true and avionics_bus>10.0)  -- avionics switch is on and avionics bus >10 volts
end

-------------- Datarefs subscribe ---------------------
fsx_variable_subscribe(
                       "NAV HAS NAV:1","bool",
                       "NAV HAS LOCALIZER:1","bool",
                       "NAV IDENT:1","string",
                       "NAV RADIAL:1","Degrees",
                       "NAV RADIAL ERROR:1","Degrees",
                       "NAV HAS NAV:2","bool",
                       "NAV HAS LOCALIZER:2","bool",
                       "NAV IDENT:2","string",
                       "NAV RADIAL:2","Degrees",
                       "NAV RADIAL ERROR:2","Degrees",
                       "AVIONICS MASTER SWITCH","bool",
                       "ELECTRICAL AVIONICS BUS VOLTAGE","volts",
                       display_params)


fs2020_variable_subscribe("NAV HAS NAV:1","bool",
                       "NAV HAS LOCALIZER:1","bool",
                       "NAV IDENT:1","string",
                       "NAV RADIAL:1","Degrees",
                       "NAV RADIAL ERROR:1","Degrees",
                       "NAV HAS NAV:2","bool",
                       "NAV HAS LOCALIZER:2","bool",
                       "NAV IDENT:2","string",
                       "NAV RADIAL:2","Degrees",
                       "NAV RADIAL ERROR:2","Degrees",
                       "AVIONICS MASTER SWITCH","bool",
                       "ELECTRICAL AVIONICS BUS VOLTAGE","volts",
                       display_params)
 
                       
function xp_display_params(nav1_has_nav,nav1_has_loc,nav1_id,nav1_radial,nav1_radial_err,nav2_has_nav,nav2_has_loc,nav2_id,nav2_radial,nav2_radial_err,avionics,avionics_bus)
fsx_nav1_has_nav=fif(nav1_has_nav==1,true, false)
print("loc:"..nav1_has_loc)
fsx_nav1_has_loc=fif(nav1_has_loc==1,true, false)
fsx_nav1_id=nav1_id
fsx_nav1_radial=nav1_radial
print("dev:"..nav1_radial_err)
fsx_nav1_radial_err=nav1_radial_err

fsx_nav2_has_nav=fif(nav2_has_nav==1,true, false)
print("loc2:"..nav2_has_loc)
fsx_nav2_has_loc=fif(nav2_has_loc==1,true, false)
fsx_nav2_id=nav2_id
fsx_nav2_radial=nav2_radial
print("dev2:"..nav2_radial_err)
fsx_nav2_radial_err=nav2_radial_err

fsx_avionics=fif(avionics==1,true,false)
fsx_avionics_bus=fif(avionics_bus==1,0.0,18.0) 
                                      
                
         display_params(fsx_nav1_has_nav,fsx_nav1_has_loc,fsx_nav1_id,fsx_nav1_radial,fsx_nav1_radial_err,fsx_nav2_has_nav,fsx_nav2_has_loc,fsx_nav2_id,fsx_nav2_radial,fsx_nav2_radial_err,fsx_avionics,fsx_avionics_bus)
                                 
end

 xpl_dataref_subscribe("sim/cockpit2/radios/indicators/nav1_display_horizontal", "int", 
                       	"sim/cockpit2/radios/indicators/nav1_type","int",
                       	"sim/cockpit2/radios/indicators/nav1_nav_id","string",
                       	"sim/cockpit2/radios/indicators/nav1_bearing_deg_mag","float",
                       	"sim/cockpit2/radios/indicators/nav1_hdef_dots_pilot","float",
                       	"sim/cockpit2/radios/indicators/nav2_display_horizontal", "int", 
                       	"sim/cockpit2/radios/indicators/nav2_type","int",
                       	"sim/cockpit2/radios/indicators/nav2_nav_id","string",
                       	"sim/cockpit2/radios/indicators/nav2_bearing_deg_mag","float",
                       	"sim/cockpit2/radios/indicators/nav2_hdef_dots_pilot","float",
                       	"sim/cockpit/electrical/avionics_on","int",
                       	"sim/operation/failures/rel_gen_avio","int",
                       xp_display_params)
                       
-- Initialization                       
request_callback(display_params)